import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Set;

import com.justep.common.SystemUtils;
import com.justep.system.context.ContextHelper;
import com.justep.system.data.DatabaseProduct;
import com.justep.system.data.KSQL;
import com.justep.system.data.ModifyState;
import com.justep.system.data.Row;
import com.justep.system.data.SQL;
import com.justep.system.data.Table;
import com.justep.system.opm.OrgUnit;
import com.justep.system.opm.OrgUtils;
import com.justep.system.process.ProcessControl;
import com.justep.system.process.ProcessControlItem;
import com.justep.system.process.ProcessUtils;
import com.justep.system.process.Task;
import com.justep.system.util.BizUtils;
import com.justep.system.util.CommonUtils;

public class WindWorkTicketProcess {

	/**
	 * 修改当前流程业务数据的状态
	 * @param state 状态
	 */
	public static void updateState(String state) {
		String sData1 = ProcessUtils.getProcessData1();
        String ksql = null;
        ksql = "update ZH_WorkTicket t set t.state='" + state + "', t.submitTime=:currentDateTime() where t= '"+sData1+"'";
        KSQL.executeUpdate(ksql, null, "/IOMM/fieldManagement/data", null);
	}
	
	/**
	 * KSQL修改data字段值
	 * @param map 字段：值(可以使用:currentDateTime())
	 */
	public static void updateData(Map<String, String> map) {
		if(map == null || map.size() == 0) {
			return ;
		}
		
		String sData1 = ProcessUtils.getProcessData1();
        String ksql = null;
        
        String sets = "";
        for (Iterator<String> iterator = map.keySet().iterator(); iterator.hasNext();) {
			String key = (String) iterator.next();
			String value = map.get(key);
			sets += " " + key + "=" + value + ",";
		}
        
		sets = sets.substring(0, sets.length() - 1);
        ksql = "update ZH_WorkTicket ZH_WorkTicket set " + sets + " where ZH_WorkTicket= '"+sData1+"'";
        KSQL.executeUpdate(ksql, null, "/IOMM/fieldManagement/data", null);
	}
	
	/**
	 * SQL修改data字段值
	 * @param map 字段：值
	 */
	public static void updateData2(Map<String, String> map) {
		if(map == null || map.size() == 0) {
			return ;
		}
		
		String sData1 = ProcessUtils.getProcessData1();
        String ksql = null;
        
        String sets = "";
        for (Iterator<String> iterator = map.keySet().iterator(); iterator.hasNext();) {
			String key = (String) iterator.next();
			String value = map.get(key);
			sets += " " + key + "=" + value + ",";
		}
        
		sets = sets.substring(0, sets.length() - 1);
        ksql = "update ZH_WorkTicket ZH_WorkTicket set " + sets + " where fid= '"+sData1+"'";
        SQL.executeUpdate(ksql, null, "/IOMM/fieldManagement/data", null);
	}
	
	/**
	 * 修改data字段值
	 * @param map 字段：值(可以使用:currentDateTime())
	 */
	public static void updateData2(Map<String, String> map, String setStr) {
		if(map == null || map.size() == 0) {
			return ;
		}
		
		String sData1 = ProcessUtils.getProcessData1();
        String ksql = null;
        
        String sets = "";
        for (Iterator<String> iterator = map.keySet().iterator(); iterator.hasNext();) {
			String key = (String) iterator.next();
			String value = map.get(key);
			sets += " " + key + "=" + value + ",";
		}
        
		
		if(setStr != null) {
			sets += setStr;
		} else {
			sets = sets.substring(0, sets.length() - 1);
		}
		
        ksql = "update ZH_WorkTicket ZH_WorkTicket set " + sets + " where ZH_WorkTicket= '"+sData1+"'";
        KSQL.executeUpdate(ksql, null, "/IOMM/fieldManagement/data", null);
	}

	public static void windWorkTicketProcessAfterStart() {
		// 检查是否存在未完成的工作票
		String sData1 = ProcessUtils.getProcessData1();
		String workOrderID = (String)BizUtils.getRelationValue("ZH_WorkTicket", sData1, 
				null, null, "workOrderID", "/IOMM/fieldManagement/data");
		// 不包含当前工作票，并且同一张工单，并且没有结束	
		String filters = "ZH_WorkTicket <> '"+sData1+"' and ZH_WorkTicket.workOrderID='" + workOrderID + 
				"' and ZH_WorkTicket.state <> '11' and ZH_WorkTicket.state <> '0' and ZH_WorkTicket.state <> '' " +
				" and ZH_WorkTicket.state <> '12' and ZH_WorkTicket.isDelete <> '1' ";
		Table workTickets = queryDataByFilters("ZH_WorkTicket", filters);
//		System.out.println(workTickets.size());
		if(workTickets != null && workTickets.size() > 0) {
			String workTicketCode = "";
			for (Iterator ite = workTickets.iterator(); ite.hasNext();) {
				Row row = (Row) ite.next();
				workTicketCode += row.getString("workTicketCode") + " ";
			}
			throw new RuntimeException("工作票流程启动失败，原因：当前工单存在未完成的工作票("+ workTicketCode +")！");
		}
		
		// 添加安全措施
		copySecurityMeasures(sData1);
		
		// 修改状态
		updateState("1");
	}
	
	// 从标准安全措施中copy至工作票的安全措施表中
	public static void copySecurityMeasures(String ticketID) {
		String sqlstr = null;
		sqlstr = "select * from ZH_SafetyMeasures where fid=?";// 工作票安措
		Map<String, String> sql = new HashMap<String, String>();
		sql.put(DatabaseProduct.DEFAULT.toString(), sqlstr);
		List<Object> binds = new ArrayList<Object>();
		binds.clear();
		binds.add(ticketID);
//		System.out.println("ticketID:" + ticketID);
		Table safetyMeasures = SQL.select(sql, binds, "/IOMM/fieldManagement/data");
//		System.out.println("工作票安措个数：" + safetyMeasures.size());
		if(safetyMeasures.size() == 0) {
			sqlstr = "select * from ZH_SecurityMeasures where sorgid=? and (type is null or type='0') ";
			binds.clear();
			String stationID = (String)BizUtils.getRelationValue("ZH_WorkTicket", ticketID, 
					null, null, "stationID", "/IOMM/fieldManagement/data");
//			String stationID = WindOrgUtils.currentWindID();// 第三方人员此方法不行
//			System.out.println("stationID:" + stationID);
//			System.out.println("sqlstr2:" + sqlstr);
			binds.add(stationID);
			// 当前风场的标准安全措施
			sql.put(DatabaseProduct.DEFAULT.toString(), sqlstr);
			Table securityMeasures = SQL.select(sql, binds, "/IOMM/fieldManagement/data");
//			System.out.println("标准安措个数：" + securityMeasures.size());
			if(securityMeasures.size() > 0) {
				for (Iterator<?> iterator = securityMeasures.iterator(); iterator.hasNext();) {
					Row row = (Row) iterator.next();
					sqlstr = "insert into ZH_SafetyMeasures (fID,version,securityMeasuresID,securityMeasuresContent," +
							"isExecute,isRunner,noticeType,remark,workTicketID,orderBy) " + 
							"values(?,?,?,?,?,?,?,?,?,?)";
					binds.clear();
					binds.add(CommonUtils.createGUID());
					binds.add(0);
					binds.add(row.getString("fID"));
					binds.add(row.getString("securityMeasuresContent"));
					binds.add("0");
					binds.add("0");
					binds.add(row.getString("lockedUpCode"));
					binds.add(row.getString("remark"));
					binds.add(ticketID);
					binds.add(row.getInteger("orderBy"));
					sql.put(DatabaseProduct.DEFAULT.toString(), sqlstr);
//					System.out.println("插入安措：" + binds.toString());
					SQL.executeUpdate(sql, binds, "/IOMM/fieldManagement/data");
				}
			}
		}
	}

	public static void draftAfterAdvance() {
		updateState("2");
	}

	public static void issueAfterAdvance() {
		updateState("3");
		
		Map<String, String> map = new HashMap<String, String>();
		map.put("ZH_WorkTicket.issuerID", ":currentPersonID()");
		map.put("ZH_WorkTicket.issuer", ":currentPersonName()");
		map.put("ZH_WorkTicket.issueTime", ":currentDateTime()");
		updateData(map);
	}

	public static void receiveAfterAdvance() {
		Set<Task> tasks = ProcessUtils.getNextTasks();
		for (Iterator iterator = tasks.iterator(); iterator.hasNext();) {
			Task task = (Task) iterator.next();
			String  activity = task.getActivity();//
			if(activity.equals("operating1")) {
				updateState("5");
			} else if(activity.equals("action")) {
				updateState("4");
			}
		}
		String sData1 = ProcessUtils.getProcessData1();
		Table workTickets = queryDataByPK("ZH_WorkTicket", sData1);
		if(workTickets.size() != 1) {
			throw new RuntimeException("未找到工作票信息，请联系管理员");
		}
		Iterator<Row> iterator = workTickets.iterator();
		Row workTicket = null;
		if(iterator.hasNext()) {
			workTicket = iterator.next();
		}
		Timestamp issueTime = null;
		Timestamp approvalStartTime = null;
		
		isNotNull(workTicket);
		issueTime = workTicket.getDateTime("issueTime");
		approvalStartTime = workTicket.getDateTime("approvalStartTime");
		
		isNotNull(issueTime);
		isNotNull(approvalStartTime);
		
//		Date issueTime = (Date)BizUtils.getRelationValue("ZH_WorkTicket", sData1, null, null, 
//				"issueTime", "/IOMM/fieldManagement/data");
		long now = System.currentTimeMillis();
		
		Map<String, String> map = new HashMap<String, String>();
//		System.out.println("issueTime.getTime()=" + issueTime.getTime());
//		System.out.println(now - issueTime.getTime() > 60 * 1000);
		
		long receive = now;
		// 接票时间>签发时间1分钟
		if(now - issueTime.getTime() > 60 * 1000) {
			map.put("ZH_WorkTicket.receiveTime", "now()");
		} else {
			receive = issueTime.getTime() + 60000;
			map.put("ZH_WorkTicket.receiveTime", "date_add(issueTime,interval 61 SECOND)");
		}
		
		// 批准时间比接收时间大于2分钟
		if(approvalStartTime.getTime() - receive <= 120000 ) {
			map.put("ZH_WorkTicket.approvalStartTime", "date_add(receiveTime,interval 121 SECOND)");
		}
		
		String currentPersonID = ContextHelper.getPerson().getID();
		String currentPersonName = ContextHelper.getPerson().getName();
		map.put("ZH_WorkTicket.receiverID", "'" + currentPersonID + "'");
		map.put("ZH_WorkTicket.receiver", "'" + currentPersonName + "'");
		map.put("ZH_WorkTicket.dutyLeaderID", "'" + currentPersonID + "'");
		map.put("ZH_WorkTicket.dutyLeader", "'" + currentPersonName + "'");
		
		// 值班负责人时间=工作票接收时间
		map.put("ZH_WorkTicket.dutyTime", "ZH_WorkTicket.receiveTime");
		
		updateData2(map);
//		if(1 == 1) {
//			throw new RuntimeException("cccccccc");
//		}
	}

	public static void isNotNull(Object o) {
		if(o == null) {
			throw new RuntimeException("对象为空");
		}
	}
	
	public static void if_operationAfterAdvance() {
		//updateState("5");
	}

	public static void operatingAfterAdvance() {
		updateState("4");
	}

	public static void actionAfterAdvance() {
		updateState("6");
		
		Map<String, String> map = new HashMap<String, String>();
		String sData1 = ProcessUtils.getProcessData1();
		Timestamp receiveTime = (Timestamp)BizUtils.getRelationValue("ZH_WorkTicket", sData1, null, null, 
				"receiveTime", "/IOMM/fieldManagement/data");
		// 措施执行时间>=工作票接收时间+10分钟
		if(System.currentTimeMillis() >=  receiveTime.getTime() + 600000) {
			map.put("ZH_WorkTicket.actionTime", "now()");
		} else {
			map.put("ZH_WorkTicket.actionTime", "date_add(receiveTime,interval 10 minute) ");
		}
		
		String currentPersonID = ContextHelper.getPerson().getID();
		String currentPersonName = ContextHelper.getPerson().getName();
		map.put("ZH_WorkTicket.actionManID", "'" + currentPersonID + "'");
		map.put("ZH_WorkTicket.actionMan", "'" + currentPersonName + "'");
		updateData2(map);
	}

	public static void permissionAfterAdvance() {
		updateState("7");
		
		String currentPersonID = ContextHelper.getPerson().getID();
		String currentPersonName = ContextHelper.getPerson().getName();
		Map<String, String> map = new HashMap<String, String>();
		map.put("ZH_WorkTicket.conditionManID", "'" + currentPersonID + "'");
		map.put("ZH_WorkTicket.conditionMan", "'" + currentPersonName + "'");
		// 具备开工时间>=措施已执行+5分钟
		String sData1 = ProcessUtils.getProcessData1();
		Timestamp actionTime = (Timestamp)BizUtils.getRelationValue("ZH_WorkTicket", sData1, null, null, 
				"actionTime", "/IOMM/fieldManagement/data");
		long now = System.currentTimeMillis();
		long condition = now;
		if(now >=  actionTime.getTime()) {
			map.put("ZH_WorkTicket.conditionTime", "now()");
		} else {
			condition = actionTime.getTime() + 300000;
			map.put("ZH_WorkTicket.conditionTime", "date_add(actionTime,interval 5 minute) ");
		}
		
		// 许可开工时间 > 具备开工条件 + 2分钟
		Timestamp permissionTime = (Timestamp)BizUtils.getRelationValue("ZH_WorkTicket", sData1, null, null, 
				"permissionTime", "/IOMM/fieldManagement/data");
		if(permissionTime == null) {
			throw new RuntimeException("许可时间必填！");
		}
		if(permissionTime.getTime() <= condition + 2 * 60 * 1000) {
			map.put("ZH_WorkTicket.permissionTime", "date_add(conditionTime,interval 121 SECOND) ");
		}
		
//		map.put("ZH_WorkTicket.conditionTime", ":currentDateTime()");
		map.put("ZH_WorkTicket.pWorkLeaderID", "workLeaderID");
		map.put("ZH_WorkTicket.pWorkLeader", "workLeader");
		map.put("ZH_WorkTicket.permissionManID",  "'" + currentPersonID + "'");
		map.put("ZH_WorkTicket.permissionMan", "'" + currentPersonName + "'");
//		updateData(map);
//		String setStr = "ZH_WorkTicket.pWorkLeaderID=ZH_WorkTicket.workLeaderID";
//		setStr += ",ZH_WorkTicket.pWorkLeader=ZH_WorkTicket.workLeader";
		updateData2(map);
	}

	public static void workingAfterAdvance() {
		updateState("8");
	}

	public static void resumeAfterAdvance() {
		Set<Task> tasks = ProcessUtils.getNextTasks();
		for (Iterator iterator = tasks.iterator(); iterator.hasNext();) {
			Task task = (Task) iterator.next();
			String  activity = task.getActivity();//
			if(activity.equals("operating2")) {
				updateState("9");
			} else if(activity.equals("over")) {
				updateState("10");
			}
		}
	}

	public static void if_operation2AfterAdvance() {
		//updateState("1");
		
	}

	public static void operating2AfterAdvance() {
		updateState("10");
	}

	public static void overAfterAdvance() {
		updateState("11");
		System.out.println("更新状态为11");
		Map<String, String> map = new HashMap<String, String>();
		map.put("ZH_WorkTicket.endTime", ":currentDateTime()");
//		map.put("ZH_WorkTicket.eWorkLeaderID", "ZH_WorkTicket.workLeaderID");
//		map.put("ZH_WorkTicket.eWorkLeader", "ZH_WorkTicket.workLeader");
		String currentPersonID = ContextHelper.getPerson().getID();
		String currentPersonName = ContextHelper.getPerson().getName();
		map.put("ZH_WorkTicket.ePermissionManID", "'" + currentPersonID + "'");
		map.put("ZH_WorkTicket.ePermissionMan", "'" + currentPersonName + "'");
//		updateData(map);
		String setStr = "ZH_WorkTicket.eWorkLeaderID=ZH_WorkTicket.workLeaderID";
		setStr += ",ZH_WorkTicket.eWorkLeader=ZH_WorkTicket.workLeader";
//		setStr += ",ZH_WorkTicket.ePermissionManID=ZH_WorkTicket.permissionManID";
//		setStr += ",ZH_WorkTicket.ePermissionMan=ZH_WorkTicket.permissionMan";
		updateData2(map, setStr);
		String sData1 = ProcessUtils.getProcessData1();
		
		String autoStartOrder = (String)BizUtils.getRelationValue("ZH_WorkTicket", sData1, null, null, 
				"autoStartOrder", "/IOMM/fieldManagement/data");
		System.out.println("autoStartOrder的值为：="+autoStartOrder);
		if(autoStartOrder == null || autoStartOrder.equals("") || autoStartOrder.equals("0")) {
			autoAdvanceWorkOrder(sData1);
		}
	}
	
	// 工作票结束，工单自动流转
	public static void autoAdvanceWorkOrder(String sData1) {
		System.out.println("工作票结束，工单自动流转");
		Table workTickets = queryDataByPK("ZH_WorkTicket", sData1);
//		System.out.println(workTickets.size());
		Iterator<Row> iteWorkTicket = workTickets.iterator();
		if(iteWorkTicket.hasNext()) {
			Row workTicket = iteWorkTicket.next();
			String workOrderID = workTicket.getString("workOrderID");
//			String workOrder = workTicket.getString("workOrder");
			String type = (String)BizUtils.getRelationValue("ZH_WorkOrder", workOrderID, null, null, 
				"type", "/IOMM/fieldManagement/data");
			String process = "";
			if("1".equals(type)) { // 缺陷单 	
				process = "/IOMM/fieldManagement/process/defectMgr/defectMgrProcess";
			} else if("2".equals(type)){ // 巡检单 
				process = "/IOMM/fieldManagement/process/inspectionList/inspectionListProcess";
			}
			Table tasks = getTaskBysData1(workOrderID, process);
			Iterator<Row> iteTasks = tasks.iterator();
			if(iteTasks.hasNext()) {
				Row task = iteTasks.next();
				String sID = task.getString("sID");
//				System.out.println("auto advance task id:" + sID);
//				System.out.println("type of workOrder:" + type);
				ProcessControl control = ProcessUtils.advanceProcessQuery(sID); 
				//修改control中的信息，如修改执行者，修改任务标题等等
				
				if("1".equals(type)) { // 缺陷单 流转给工作负责人
					for (ProcessControlItem to : control.getFlowTos()){
						//修改默认执行者,流转给工作负责人
						to.clearExecutors();
						String workLeaderID = workTicket.getString("workLeaderID");
						to.addExecutor(OrgUtils.findOrgUnitsByID(workLeaderID).get(0));
					}
				} else if("2".equals(type)){ // 巡检单 自动流转给站长
					
				}
				ProcessUtils.advanceProcess(sID, control);
//				System.out.println("auto advance ok......");
			}
		}
	}

	public static Table getTaskBysData1(String sData1, String process) {
		String sqlstr = "select * from SA_Task SA_Task where SA_Task.sData1=? "+
				"and (SA_Task.sEURL is not null and SA_Task.sCURL is not null)"+
				"and (SA_Task.sKindID='tkTask' or SA_Task.sKindID='tkExecutor' or SA_Task.sKindID IS NULL)"+
				"and (SA_Task.sProcess='" + process+ "')"+
				"order by sData1 ,sCreateTime desc,sKindID desc,sAIStatusID desc";
		
		Map<String, String> sql = new HashMap<String, String>();
		sql.put(DatabaseProduct.DEFAULT.toString(), sqlstr);
		
		List<Object> binds = new ArrayList<Object>();
		binds.add(sData1);
		
		Table table = SQL.select(sql, binds, "/system/data");
		
		return table;
	}
	
	public static Table getTaskBysData1(String sData1) {
		String sqlstr = "select * from SA_Task SA_Task where SA_Task.sData1=? "+
				"and (SA_Task.sEURL is not null and SA_Task.sCURL is not null)"+
				"and (SA_Task.sKindID='tkTask' or SA_Task.sKindID='tkExecutor' or SA_Task.sKindID IS NULL)"+
				"and (SA_Task.sProcess='/IOMM/fieldManagement/process/defectMgr/defectMgrProcess')"+
				"order by sData1 ,sCreateTime desc,sKindID desc,sAIStatusID desc";
		
		Map<String, String> sql = new HashMap<String, String>();
		sql.put(DatabaseProduct.DEFAULT.toString(), sqlstr);
		
		List<Object> binds = new ArrayList<Object>();
		binds.add(sData1);
		
		Table table = SQL.select(sql, binds, "/system/data");
		
		return table;
	}
	
	// 起草流转查询之后
	public static void draftAfterAdvanceQuery() {
		String sData1 = ProcessUtils.getProcessData1();
		String workOrderID = (String)BizUtils.getRelationValue("ZH_WorkTicket", sData1, null, null, 
				"workOrderID", "/IOMM/fieldManagement/data");
				
		String notifierID = (String)BizUtils.getRelationValue("ZH_DefectList", workOrderID, null, null, 
				"notifierID", "/IOMM/fieldManagement/data");
				
		List<OrgUnit> list = OrgUtils.findOrgUnitsByID(notifierID);
		if(list == null || list.size() == 0) {
			// 工单中的通知人(场站)不存在，下一个环节没有默认执行者
			return ;
		}
		OrgUnit executor = list.get(0);
		
		ProcessControl control = ProcessUtils.getProcessContext().getProcessControl();
		for (ProcessControlItem to : control.getFlowTos()){
			//修改默认执行者
			to.clearExecutors();
			to.addExecutor(executor);
			
			WindUtils.checkWorkingManByWind(sData1);
		}
	}

	// 流程启动之前
	public static void windWorkTicketProcessBeforeStart() {
//		String sData1 = ProcessUtils.getProcessData1();
//		System.out.println(sData1);// null
	}
	
	public static Table queryDataByFilters(String tableName,String filters) {
        String ksql = null;
        
		String where = " where 1=1 ";
		if(filters != null) {
			where += " and " + filters;
		}
        ksql = "select "+tableName+".* from "+tableName+" " + tableName  + where;
        return KSQL.select(ksql, null, "/IOMM/fieldManagement/data", null);
	}
	
	public static Table queryData(String tableName, Map<String, String> conditions) {
        String ksql = null;
        
		String where = " where 1=1 ";
		 for (Iterator<String> iterator = conditions.keySet().iterator(); iterator.hasNext();) {
			String key = (String) iterator.next();
			String value = conditions.get(key);
			where += " and "+tableName+"." + key + "=" + value + " ";
		}
		
        ksql = "select "+tableName+".* from "+tableName+" " + tableName  + where;
        return KSQL.select(ksql, null, "/IOMM/fieldManagement/data", null);
	}
	
	public static Table queryDataByPK(String tableName, String pk) {
        String ksql = null;
		ksql = "select " + tableName + ".* from " + tableName + " " + tableName + " where " + tableName + "='" + pk + "' ";
        return KSQL.select(ksql, null, "/IOMM/fieldManagement/data", null);
	}

	public static void permissionAfterAdvanceQuery() {
		String sData1 = ProcessUtils.getProcessData1();
		String workLeaderID = (String) BizUtils.getRelationValue("ZH_WorkTicket", sData1, 
				null, null, "workLeaderID", "/IOMM/fieldManagement/data");
		workLeaderID = workLeaderID.split("@")[0];
		
		OrgUnit workLeader = OrgUtils.findOrgUnitsByID(workLeaderID).get(0);
		
		ProcessControl control = ProcessUtils.getProcessContext().getProcessControl();
		for (ProcessControlItem to : control.getFlowTos()){
			//修改默认执行者
			to.clearExecutors();
			to.addExecutor(workLeader);
		}
		
	}

	public static Table windWorkTicketProcessBeforeSaveZH_WorkTicketAction() {
//		System.out.println("start...");
		
		Table table = (Table)ContextHelper.getActionContext().getParameters().get("table");
		Iterator<Row> iterator = table.iterator();
		Date currentDate = CommonUtils.getCurrentDate();
		String dateStr = CommonUtils.dateFormat(currentDate, "yyMM");
		while (iterator.hasNext()) {
			Row row = (Row)iterator.next();
			String stationID = (String)row.getString("stationID");
			ModifyState state = row.getState();
//			System.out.println(state + "-" + stationID + "-" + row.isModified("stationID")); 
			if(ModifyState.NEW.equals(state)) {
				if(stationID != null && !stationID.equals("")) {
					// concat(currentWindCode1(),'FJ',dateFormat(currentDate(),'yyMM'), '')
					String code = (String)BizUtils.getRelationValue("SA_OPOrg", stationID, null, null, "sCode", "/system/data");
					String prefix = CommonUtils.concat(code, "FJ", dateStr);
					code = CodeUtils.getNextWorkTicketCode(prefix);
//					System.out.println(code);
					row.setString("workTicketCode", code);
				} else {
					throw new RuntimeException("场站必须有值！");
				}
			} else if(ModifyState.EDIT.equals(state)) {
				if(!row.isModified("stationID")) {
					continue;
				}
				if(stationID != null && !stationID.equals("")) {
					// concat(currentWindCode1(),'FJ',dateFormat(currentDate(),'yyMM'), '')
					String code = (String)BizUtils.getRelationValue("SA_OPOrg", stationID, null, null, "sCode", "/system/data");
					String prefix = CommonUtils.concat(code, "FJ", dateStr);
					code = CodeUtils.getNextWorkTicketCode(prefix);
//					System.out.println(code);
					row.setString("workTicketCode", code);
				} else {
					throw new RuntimeException("场站必须有值！");
				}
			}
		}
		
//		System.out.println("end...");
		return table;
	}
	
	// 接票流转查询
	public static void receiveAfterAdvanceQuery() {
		String sData1 = ProcessUtils.getProcessData1();
		String workLeaderID = (String) BizUtils.getRelationValue("ZH_WorkTicket", sData1, 
				null, null, "workLeaderID", "/IOMM/fieldManagement/data");
		workLeaderID = workLeaderID.split("@")[0];
		
		OrgUnit workLeader = OrgUtils.findOrgUnitsByID(workLeaderID).get(0);
		
		ProcessControl control = ProcessUtils.getProcessContext().getProcessControl();
		for (ProcessControlItem to : control.getFlowTos()){
			//修改默认执行者
			to.clearExecutors();
			to.addExecutor(workLeader);
		}
		
	}
}