define(function(require){
	var $ = require("jquery");
	var justep = require("$UI/system/lib/justep");
	var biz = require('$UI/system/lib/biz');
	var Tools = require("$UI/IOMM/common/js/tools");
	
	var Model = function(){
		this.callParent();
	};

	// 接收参数
	Model.prototype.modelParamsReceive = function(event){
		if(!event.data) {
			return ;
		}
		var task = event.data.task;
		var sData1 = event.data.sData1;
		var mainData = this.comp("mainData");
		if(sData1) {
			mainData.setFilter("filter", "ZH_WorkTicket='" + sData1 + "'");
			mainData.refreshData();
		} else {
			mainData.newData();
		}
		this.getParentModel().getContext().data.params.sData1 = mainData.getRowID();
		
		
		var process = this.comp("process1");
		if(task) {
			process.set({task : task});
		}
		
	};
	
	// 选择场站
	Model.prototype.button1Click = function(event){
		this.comp("stationDialog").open({
			data : {
				code : ["wind"], 
				rootFilter : '-1',
				rootFilterStr : "SA_OPOrg.sOrgKindID='wind'"
			}
		});
	};

	// 选择工单
	Model.prototype.button2Click = function(event){debugger;
		var context = this.getContext();
		var currentWindID = context.getSystemParameter("currentWindID");
		if(currentWindID && currentWindID !== null) {
			this.comp("workOrderDialog").open({data : {filter : [
                 {type : "1", state : "5", stationID : currentWindID}, 
                 {type : "2", state : "3", stationID : currentWindID},
                 {type : "3", state : "3", stationID : currentWindID}]
			}});
		} else {
			this.comp("workOrderDialog").open({data : {filter : [
                 {type : "1", state : "5"}, 
                 {type : "2", state : "3"},
                 {type : "3", state : "3"}]
			}});
		}
	};
	
	// 选择工作负责人
	Model.prototype.button3Click = function(event){
		var options = {};
		options.data = {};
		options.data.code = "psm";
		options.data.role = "gzfzr";
		var stationID = this.comp("mainData").getValue("stationID");
		if(stationID && stationID !== "") {
			options.data.rootFilter = stationID;
		} else {
			justep.Util.hint("请先选择场站");
			return false;
		}
		options.data.rootFilterCode = 'CJ';//第三方机构scode
		
		// 查询出正在工作的人员
		Tools.callAction(this.getContext(), "queryWorkMen", {}, function(result){
			if(result.state) {
				options.data.filterStr = result.response;
			}
		});
		
		this.comp("workLeaderDialog").open(options);
	
//		var context = this.getContext();
//		var currentOgnID = context.getCurrentOgnID();
//		var rootFilter = "" + currentOgnID + "' or SA_OPOrg.sCode='CJ";
//		this.comp("workLeaderDialog").open({data : {code : "psm", rootFilter : rootFilter}});
	};
	
	// 选择班组
	Model.prototype.button4Click = function(event){
		this.comp("groupDialog").open({data : {rootFilterCode : "HDFX", code : ["wind"]}});
	};
	
	// 保存
	Model.prototype.toSaveMainData = function(event){
		var mainData = this.comp("mainData");
		var isValid = mainData.isValid(true);
		if(!isValid) {
			var invalidInfo = mainData.getInvalidInfo(true);
			return {isValid : isValid, invalidInfo : invalidInfo};
		}
		
		var self = this;
		if((mainData.getValue("state") === "0" || mainData.getValue("state") === undefined) || mainData.getValue("state") === "") {
			// 保存
			if(!mainData.isChanged()) {
				self.startProcess(mainData);
				return isValid;
			}
			mainData.saveData({
				onSuccess : function(event) {
					justep.Util.hint("保存成功");
					self.startProcess(event.source);
				},
				onError : function(event) {
					justep.Util.hint("保存失败");
				}
			});
		} else {
			mainData.saveData({
				onSuccess : function(event) {
					justep.Util.hint("保存成功");
				},
				onError : function(event) {
					justep.Util.hint("保存失败");
				}
			});
		}
		return isValid;
	};
	
	// 启动流程
	Model.prototype.startProcess = function(mainData){
		var self = this;
		// 启动流程
		this.comp("process1").start('/IOMM/fieldManagement/process/windWorkTicket/windWorkTicketProcess', null, mainData.getRowID(),
			{
				onSuccess : function() {
					justep.Util.hint("流程启动成功");
					self.refreshData(mainData);
					if(self.getParentModel() && self.getParentModel().comp("workTicket")) {
						self.getParentModel().comp("workTicket").refreshData();
						self.getParentModel().comp("workTicket").to(mainData.getRowID());
					}
					self.updateTaskTitleByData(mainData);
					
				},
				onError : function() {
					justep.Util.hint("流程启动失败");
					mainData.setValue("state", "0");
					mainData.saveData();
				}
			}
		);
	};
	
	Model.prototype.refreshData = function(data){
		var rowID = data.getRowID();
		data.filters.clear();
		data.setFilter("filter", "ZH_WorkTicket='" + rowID + "'");
		 var confirmRefresh = data.confirmRefresh;
		 try{
			 data.confirmRefresh = false;
			 data.refreshData();
		 }finally{
			 data.confirmRefresh = confirmRefresh;
		 }
		 
	};

	// 去掉透明div覆盖class
	Model.prototype.clearOverlay = function(event){
		$("#x-default-overlay").removeClass("x-default-overlay-open");
	};
	
	// 选择工作人员
	Model.prototype.button5Click = function(event){
		var workLeaderID = this.comp("mainData").getValue("workLeaderID");
		var stationID = this.comp("mainData").getValue("stationID");
		var options = {data : {code : "psm", filters : {sPersonID : workLeaderID}}};
		if(stationID && stationID !== "") {
			options.data.rootFilter = stationID;
		} else {
			justep.Util.hint("请先选择场站");
			return false;
		}
	
		options.data.rootFilterCode = 'CJ';//第三方机构scode
		
		var multiOrgDialog = this.comp("multiOrgDialog");
		
		// 查询出正在工作的人员
		Tools.callAction(this.getContext(), "queryWorkMen", {}, function(result){
			if(result.state) {
				options.data.filterStr = result.response;
				multiOrgDialog.open(options);
			}
		});
	
//		var workLeaderID = this.comp("mainData").getValue("workLeaderID");
//		this.comp("multiOrgDialog").open({data : {code : "psm", filters : {sPersonID : workLeaderID}}});
	};

	// 选择位置
	Model.prototype.button7Click = function(event){
		var stationID = this.comp("mainData").getValue("stationID");
		if(stationID && stationID !== "") {
			this.comp("locDialog").open({data : {stationID : stationID}});
		} else {
			justep.Util.hint("请先选择场站");
		}
	};

	Model.prototype.button9Click = function(event){
		this.comp("mainData").setValue("workers", "");
		this.comp("mainData").setValue("workersID", "");
		this.comp("mainData").setValue("workersCount", "");
	};

	Model.prototype.multiOrgDialogReceive = function(event){};

	// 位置级联设置设备的值
	Model.prototype.locDialogReceived = function(event){
		var data = event.data;
		var ZH_EquipmentLocation = data.val('ZH_EquipmentLocation');
		var doubleCode = event.data.val("doubleCode");
		
		var options={};
		var params = new biz.Request.ActionParam();
		params.setString("id", ZH_EquipmentLocation);
		options.context = this.getContext();
		options.action = "getDeviceByLocID";
		options.parameters = params;
		try{
			var table = biz.Request.sendBizRequest(options);
			var rows = table.responseJSON.data.value.rows;
			var mainData = this.comp("mainData");
			if(1 == rows.length) {
//				var ZH_EquipmentLedger = rows[0]['ZH_EquipmentLedger'].value;
//				var equipmentCode = rows[0]['equipmentCode'].value;
				var equipmentName = rows[0]['equipmentName'].value;
				var workPlace = equipmentName;
				if(doubleCode && doubleCode !== "") {
					workPlace += "(" + doubleCode + ")";
				}
				mainData.setValue("workPlace", workPlace);
				
			} else {
				mainData.setValue("workPlace", "");
			}
		}catch(e){
			justep.Util.hint("查询出错，稍后重试");
		}
	};
	
	// data变化 设置父页面保存按钮
	Model.prototype.mainDataDataChange = function(event){
		if("valueChanged" == event.type) {
			this.getParentModel().comp("saveBtn").set({disabled : false});
		}
	};
	
	// data值变化
	Model.prototype.mainDataValueChange = function(event){
		if(event.col == "workers") {
			var count = 0;
			if(event.newValue && event.newValue !== "") {
				count = (event.newValue + "").split(",").length;
			}
			
			if(event.source.getValue("workLeader") && event.source.getValue("workLeader") !== "") {
				count += 1;
			}
//			alert("change:" + count);
			event.source.setValue("workersCount", count);
		}
	};
	 
	// 选择工单：根据位置ID查询工作地点
	Model.prototype.workOrderDialogReceived = function(event){
		var data = event.data;
		var locationID = data.val('locationID');
		
		var options={};
		var params = new biz.Request.ActionParam();
		params.setString("id", locationID);
		options.context = this.getContext();
		options.action = "getAddressByLocID";
		options.parameters = params;
		try{
			var table = biz.Request.sendBizRequest(options);
			var rows = table.responseJSON.data.value.rows;
			var mainData = this.comp("mainData");
			if(1 == rows.length) {
				var equipmentName = rows[0]['equipmentName'].value;
				var doubleCode = rows[0]['doubleCode'].value;
				var workPlace = equipmentName;
				if(doubleCode && doubleCode !== "") {
					workPlace += "(" + doubleCode + ")";
				}
				mainData.setValue("workPlace", workPlace);
				
			} else {
				mainData.setValue("workPlace", "无");
			}
		}catch(e){
			justep.Util.hint("查询出错，稍后重试");
		}
	};
	
	// 修改任务标题
	Model.prototype.updateTaskTitleByData = function(mainData){
		var task, title;
		var taskData = this.getParentModel().getTaskBysData1(mainData.getRowID());
		task = taskData.getRowID();
		var workTicketCode = mainData.getValue("workTicketCode");
		var workContent = mainData.getValue("workContent");
		title = "'" + workTicketCode + "  <', t.sActivityName, '>  " + workContent + "'";
		this.updateTaskTitle(task, title);
	};
	
	// 修改任务标题
	Model.prototype.updateTaskTitle = function(task, title){
		var options={};
		var params = new biz.Request.ActionParam();
		params.setString("task", task);
		params.setString("title", title);
		options.context = this.getContext();
		options.action = "updateTaskTitle";
		options.parameters = params;
		try{
			biz.Request.sendBizRequest(options);
		}catch(e){
			
		}
	};
	
	// 获取state的name
	Model.prototype.getCodeName = function(xid, code){ 
		var pmodel = this.getParentModel();
		if(!pmodel) {
			return code;
		} 
		var data = pmodel.comp(xid);
		var name = code;
		data.each(function(p){
			var row = p.row;
			if(code && (row.val("code") == code)) {
				name = row.val("name");
				p.cancel = true;
			}
		});
		return name;
	};
	 
	Model.prototype.mainDataBeforeSave = function(event){
		var row = event.source.getCurrentRow();
		if(event.source.getRowState(row) == "new") {
			//第一次保存
			this.getNextWorkTicketCode(event);
			
		}
	};
	
	Model.prototype.getNextWorkTicketCode = function(event){
		var mainData = this.comp("mainData");
		var row = event.source.getCurrentRow();
		var prefix = event.source.getValue("workTicketCode", row);
		var biz = require('$UI/system/lib/biz');
		var options={};
		var params = new biz.Request.ActionParam();
		params.setString("prefix", prefix);
		options.context = this.getContext();
		options.action = "getNextWorkTicketCode";
		options.parameters = params;
		options.directExecute = true;
		options.callback = function(data){
			if(data.state) {
				mainData.setValue("workTicketCode", data.response);
			} else {
				justep.Util.hint("工作票编号生成出错");
				throw new Error();
			}
		};
		biz.Request.sendBizRequest(options);
	};
	 
	return Model;
});