define(function(require){
	var $ = require("jquery");
	var justep = require("$UI/system/lib/justep");
	var biz = require('$UI/system/lib/biz');
	var Tools = require("$UI/IOMM/common/js/tools");
	require("css!$UI/IOMM/common/css/tileflow").load();
	var Model = function(){
		this.callParent();
		this.initOK = justep.Bind.observable(false);
		this.readonly = justep.Bind.observable(true);
		this.readonlyData = justep.Bind.observable(false);
		this.isReadonly = justep.Bind.computed(function() {
			if (!this.initOK.get()) {
				return false;
			}
			return this.readonly.get();
		}, this);
	};
	
	Model.prototype.safetyMeasuresIsReadonly = function() {
		var state = this.comp("mainData").getValue("state");
		var a = !(this.readonlyData.get()) && (state == '1' || state == '4');
		return !a;
	};

	// 接收参数
	Model.prototype.modelParamsReceive = function(event){
//		var isreadonlyBtn = this.__context.data.params._pagePattern;//用于判断当前人和当前执行人是否相等	
//		this.isreadonlyBtn(isreadonlyBtn);
		if(!(event.data)) {
			
			return ;
		}
		var _pagePattern = event.data._pagePattern;
		this.readonly.set(_pagePattern == "readonly");	
		if(_pagePattern == "readonly"){
			Tools.disabledBtn(this, "button4,button19,button2,saveButton,backButton,abortButton");
		}
		this.initOK.set(true);	
	};
	
	// 选择场站
	Model.prototype.button1Click = function(event){
		this.comp("stationDialog").open({
			data : {
				code : ["wind"], 
				rootFilter : '-1',
				rootFilterStr : "SA_OPOrg.sOrgKindID='wind'"
			}
		});
	};

	// 选择工单
	Model.prototype.button2Click = function(event){ 
		var context = this.getContext();
//		var currentWindID = context.getSystemParameter("currentWindID");
		var mainData = this.comp("mainData");
		var currentWindID = mainData.val("stationID");
		if(currentWindID && currentWindID !== null) {
			this.comp("workOrderDialog").open({data : {filter : [
                 {type : "1", state : "5", stationID : currentWindID}, 
                 {type : "2", state : "3", stationID : currentWindID},
                 {type : "3", state : "3", stationID : currentWindID}]
			}});
		} else {
			this.comp("workOrderDialog").open({data : {filter : [
                 {type : "1", state : "5"}, 
                 {type : "2", state : "3"},
                 {type : "3", state : "3"}]
			}});
		}
	};
	
	// 选择工作负责人
	Model.prototype.button3Click = function(event){
		var options = {};
		options.data = {};
		options.data.code = "psm";
		options.data.role = "gzfzr";
		var stationID = this.comp("mainData").getValue("stationID");
		if(stationID && stationID !== "") {
			options.data.rootFilter = stationID;
		} else {
			justep.Util.hint("请先选择场站");
			return false;
		}
		options.data.rootFilterCode = 'CJ';//第三方机构scode
		
		// 查询出正在工作的人员
		Tools.callAction(this.getContext(), "queryWorkMen", {}, function(result){
			if(result.state) {
				options.data.filterStr = result.response;
			}
		});
		
		this.comp("workLeaderDialog").open(options);
	
//		var context = this.getContext();
//		var currentOgnID = context.getCurrentOgnID();
//		var rootFilter = "" + currentOgnID + "' or SA_OPOrg.sCode='CJ";
//		this.comp("workLeaderDialog").open({data : {code : "psm", rootFilter : rootFilter}});
	};
	
	// 选择班组
	Model.prototype.button4Click = function(event){
		this.comp("groupDialog").open({data : {rootFilterCode : "HDFX", code : ["wind"]}});
	};
	
	// 保存
	Model.prototype.toSaveMainData = function(event){
//		var mainData = this.comp("mainData");
//		var isValid = mainData.isValid(true);
//		if(!isValid) {
//			var invalidInfo = mainData.getInvalidInfo(true);
//			return {isValid : isValid, invalidInfo : invalidInfo};
//		}
//		
//		var self = this;
//		if((mainData.getValue("state") === "0" || mainData.getValue("state") === undefined) || mainData.getValue("state") === "") {
//			// 保存
//			if(!mainData.isChanged()) {
//				self.startProcess(mainData);
//				return isValid;
//			}
//			mainData.saveData({
//				onSuccess : function(event) {
//					justep.Util.hint("保存成功");
//					self.startProcess(event.source);
//				},
//				onError : function(event) {
//					justep.Util.hint("保存失败");
//				}
//			});
//		} else {
//			mainData.saveData({
//				onSuccess : function(event) {
//					justep.Util.hint("保存成功");
//				},
//				onError : function(event) {
//					justep.Util.hint("保存失败");
//				}
//			});
//		}
//		return isValid;
	};
	
	// 启动流程
	Model.prototype.startProcess = function(mainData){
//		var self = this;
//		// 启动流程
//		this.comp("process1").start('/IOMM/fieldManagement/process/windWorkTicket/windWorkTicketProcess', null, mainData.getRowID(),
//			{
//				onSuccess : function() {
//					justep.Util.hint("流程启动成功");
//					self.refreshData(mainData);
//					if(self.getParentModel() && self.getParentModel().comp("workTicket")) {
//						self.getParentModel().comp("workTicket").refreshData();
//						self.getParentModel().comp("workTicket").to(mainData.getRowID());
//					}
//					self.updateTaskTitleByData(mainData);
//					
//				},
//				onError : function() {
//					justep.Util.hint("流程启动失败");
//					mainData.setValue("state", "0");
//					mainData.saveData();
//				}
//			}
//		);
	};
	
	Model.prototype.refreshData = function(data){
		var rowID = data.getRowID();
		data.filters.clear();
		data.setFilter("filter", "ZH_WorkTicket='" + rowID + "'");
		 var confirmRefresh = data.confirmRefresh;
		 try{
			 data.confirmRefresh = false;
			 data.refreshData();
		 }finally{
			 data.confirmRefresh = confirmRefresh;
		 }
		 
	};

	// 去掉透明div覆盖class
	Model.prototype.clearOverlay = function(event){
		$("#x-default-overlay").removeClass("x-default-overlay-open");
	};
	
	// 选择工作人员
	Model.prototype.button5Click = function(event){
		var workLeaderID = this.comp("mainData").getValue("workLeaderID");
		var stationID = this.comp("mainData").getValue("stationID");
		var options = {data : {code : "psm", filters : {sPersonID : workLeaderID}}};
		if(stationID && stationID !== "") {
			options.data.rootFilter = stationID;
		} else {
			justep.Util.hint("请先选择场站");
			return false;
		}
	
		options.data.rootFilterCode = 'CJ';//第三方机构scode
		
		var multiOrgDialog = this.comp("multiOrgDialog");
		
		// 查询出正在工作的人员
		Tools.callAction(this.getContext(), "queryWorkMen", {}, function(result){
			if(result.state) {
				options.data.filterStr = result.response;
				multiOrgDialog.open(options);
			}
		});
	
//		var workLeaderID = this.comp("mainData").getValue("workLeaderID");
//		this.comp("multiOrgDialog").open({data : {code : "psm", filters : {sPersonID : workLeaderID}}});
	};

	// 选择位置
	Model.prototype.button7Click = function(event){
		var stationID = this.comp("mainData").getValue("stationID");
		if(stationID && stationID !== "") {
			this.comp("locDialog").open({data : {stationID : stationID}});
		} else {
			justep.Util.hint("请先选择场站");
		}
	};

	Model.prototype.button9Click = function(event){
		this.comp("mainData").setValue("workers", "");
		this.comp("mainData").setValue("workersID", "");
		this.comp("mainData").setValue("workersCount", "");
	};

	Model.prototype.multiOrgDialogReceive = function(event){};

	// 位置级联设置设备的值
	Model.prototype.locDialogReceived = function(event){
		var data = event.data;
		var ZH_EquipmentLocation = data.val('ZH_EquipmentLocation');
		var doubleCode = event.data.val("doubleCode");
		
		var options={};
		var params = new biz.Request.ActionParam();
		params.setString("id", ZH_EquipmentLocation);
		options.context = this.getContext();
		options.action = "getDeviceByLocID";
		options.parameters = params;
		try{
			var table = biz.Request.sendBizRequest(options);
			var rows = table.responseJSON.data.value.rows;
			var mainData = this.comp("mainData");
			if(1 == rows.length) {
//				var ZH_EquipmentLedger = rows[0]['ZH_EquipmentLedger'].value;
//				var equipmentCode = rows[0]['equipmentCode'].value;
				var equipmentName = rows[0]['equipmentName'].value;
				var workPlace = equipmentName;
				if(doubleCode && doubleCode !== "") {
					workPlace += "(" + doubleCode + ")";
				}
				mainData.setValue("workPlace", workPlace);
				
			} else {
				mainData.setValue("workPlace", "");
			}
		}catch(e){
			justep.Util.hint("查询出错，稍后重试");
		}
	};
	
	// data变化 设置父页面保存按钮
	Model.prototype.mainDataDataChange = function(event){
//		if("valueChanged" == event.type) {
//			this.getParentModel().comp("saveBtn").set({disabled : false});
//		}
	};
	
	// data值变化
	Model.prototype.mainDataValueChange = function(event){
		if(event.col == "workers") {
			var count = 0;
			if(event.newValue && event.newValue !== "") {
				count = (event.newValue + "").split(",").length;
			}
			
			if(event.source.getValue("workLeader") && event.source.getValue("workLeader") !== "") {
				count += 1;
			}
//			alert("change:" + count);
			event.source.setValue("workersCount", count);
		}
	};
	 
	// 选择工单：根据位置ID查询工作地点
	Model.prototype.workOrderDialogReceived = function(event){ 
		var data = event.data;
		var locationID = data.val('locationID');
		
		var options={};
		var params = new biz.Request.ActionParam();
		params.setString("id", locationID);
		options.context = this.getContext();
		options.action = "getAddressByLocID";
		options.parameters = params;
		try{
			var table = biz.Request.sendBizRequest(options);
			var rows = table.responseJSON.data.value.rows;
			var mainData = this.comp("mainData");
			if(1 == rows.length) {
				var equipmentName = rows[0]['equipmentName'].value;
				var doubleCode = rows[0]['doubleCode'].value;
				var workPlace = equipmentName;
				if(doubleCode && doubleCode !== "") {
					workPlace += "(" + doubleCode + ")";
				}
				mainData.setValue("workPlace", workPlace);
				
			} else {
				mainData.setValue("workPlace", "无");
			}
		}catch(e){
			justep.Util.hint("查询出错，稍后重试");
		}
	};
	
	// 修改任务标题
	Model.prototype.updateTaskTitleByData = function(mainData){
		var task, title;
		var taskData = this.getParentModel().getTaskBysData1(mainData.getRowID());
		task = taskData.getRowID();
		var workTicketCode = mainData.getValue("workTicketCode");
		var workContent = mainData.getValue("workContent");
		title = "'" + workTicketCode + "  <', t.sActivityName, '>  " + workContent + "'";
		this.updateTaskTitle(task, title);
	};
	
	// 修改任务标题
	Model.prototype.updateTaskTitle = function(task, title){
		var options={};
		var params = new biz.Request.ActionParam();
		params.setString("task", task);
		params.setString("title", title);
		options.context = this.getContext();
		options.action = "updateTaskTitle";
		options.parameters = params;
		try{
			biz.Request.sendBizRequest(options);
		}catch(e){
			
		}
	};
	
	// 获取state的name
	Model.prototype.getCodeName = function(xid, code){ 
		var pmodel = this.getParentModel();
		if(!pmodel) {
			return code;
		} 
		var data = pmodel.comp(xid);
		var name = code;
		data.each(function(p){
			var row = p.row;
			if(code && (row.val("code") == code)) {
				name = row.val("name");
				p.cancel = true;
			}
		});
		return name;
	};
	 
	Model.prototype.moreBtnClick = function(event){
		this.comp("processMenu").show();
	};
	 

	Model.prototype.list1Click = function(event){

	};

	Model.prototype.listClick = function(event){
		
	};

	Model.prototype.button25Click = function(event){
		this.comp("newSafeMesMenu").show();
	};

	Model.prototype.button12Click = function(event){
		this.comp("safetyMeasuresDialog").open();
	};
	
	// new安措
	Model.prototype.button17Click = function(event){
		var safetyMeasuresData = this.comp("safetyMeasures");
		safetyMeasuresData.newData();
	};

	Model.prototype.updateSafty = function(e, rowID, colName, dataXid, colVal) { 
//		var temMenu = this.comp("temMenu");
//		temMenu.show();
//		var menuBox = $(this.getElementByXid("menu3"));
//
//		// 默认窗口可视区域鼠标位置右下
//		var menuBox_width = menuBox.width();
//		var menuBox_height = menuBox.height();
//		var window_width = $(window).width();
//		var window_height = $(window).height();
//		var x = e.clientX + menuBox_width / 2;
//		var y = e.clientY + menuBox_height / 2;
//		if (e.clientX > window_width - menuBox_width) {
//			x = e.clientX - menuBox_width / 2;
//		}
//		if (e.clientY > window_height - menuBox_height) {
//			y = e.clientY - menuBox_height / 2;
//		}
//
//		menuBox.css("top", y);
//		menuBox.css("left", x);
//
//		// menuBox.data({"_rowID" : rowID, "_colName" : colName});
//
//		menuBox.empty();
//		var menu3 = this.comp("menu3");
//
//		var data = this.comp(dataXid);
//		data.each(function(p) { 
//			var row = p.row;
//			var attr = "";
//			if (colVal && (row.val("code") == colVal)) {
//				attr = "style='color:#016d92;font-weight: bold;";
//			}
//			menu3.addItem({
//				label : "<div " + attr + " onclick='justep.Bind.contextFor(this).$model.doUpdateSafty(" + "\"" + rowID + "\", \"" + colName + "\", \"" + row.val("code") + "\")'>" + row.val("name")
//						+ "</div>"
//			});
//		});
//
//		event.stopPropagation();// 停止事件的传播，否则还会出发RowClick事件
	};
	

	
	Model.prototype.input3Render = function(event){ 
//		var state;
////		if (event.colName == 'isExecute') {
//			
//			var safetyMeasures = this.comp("safetyMeasures");
//			var rowID = safetyMeasures.val("ZH_SafetyMeasures");
//			var isExecute = safetyMeasures.val("isExecute");
////			var isExecute = event.value;	
//			var isExecuteCol = "isExecute";
//			var isExecutevalue = safetyMeasures.val("isExecute");
//			var executeState = this.comp("executeState");
//			executeState.each(function(p) { 
//				var row = p.row;
//				if (isExecute && (row.val("code") == isExecute)) {
//					isExecute = row.val("name");
//					p.cancel = true;
//				}
//			});
//			isExecute = isExecute || "          ";
//			state = this.comp("mainData").getValue("state");
////			if (!(this.readonlyData.get()) && (state == "1" || state == "4")) {// !this.readonlyData.get()表示数据权限可编辑
//				event.html = "<div class='btn-link grid-link' onclick='justep.Bind.contextFor(this).$model.	(event,\"" + rowID + "\", \"" + isExecuteCol + "\", \"executeState\", \""
//						+ isExecutevalue + "\")'>" + isExecute + "</div>";
////			} 
////			else {
////				event.html = isExecute;
////			}
////		}
	};
	
	Model.prototype.doUpdateSafty = function(rowID, colName, val) {
		this.comp("safetyMeasures").setValueByID(colName, val, rowID);
	};
	

	
	Model.prototype.listAfterRender = function(event){
		/* 
		var state;
		if (event.colName == 'isExecute') {
			var isExecute = event.colVal;
			var executeState = this.comp("executeState");
			executeState.each(function(p) {
				var row = p.row;
				if (event.colVal && (row.val("code") == event.colVal)) {
					isExecute = row.val("name");
					p.cancel = true;
				}
			});
			isExecute = isExecute || "          ";
			state = this.comp("workTicket").getValue("state");
			if (!(this.readonlyData.get()) && (state == "1" || state == "4")) {// !this.readonlyData.get()表示数据权限可编辑
				event.html = "<div class='btn-link grid-link' onclick='justep.Bind.contextFor(this).$model.updateSafty(event,\"" + event.rowID + "\", \"" + event.colName + "\", \"executeState\", \""
						+ event.colVal + "\")'>" + isExecute + "</div>";
			} else {
				event.html = isExecute;
			}
		} else if (event.colName == 'isRunner') {
			var isRunner = event.colVal;
			var runnerState = this.comp("runnerState");
			runnerState.each(function(p) {
				var row = p.row;
				if (event.colVal && (row.val("code") == event.colVal)) {
					isRunner = row.val("name");
					p.cancel = true;
				}
			});
			isRunner = isRunner || "          ";
			state = this.comp("workTicket").getValue("state");
			if (!(this.readonlyData.get()) && state == "1") {// !this.readonlyData.get()表示数据权限可编辑
				event.html = "<div class='btn-link grid-link' onclick='justep.Bind.contextFor(this).$model.updateSafty(event,\"" + event.rowID + "\", \"" + event.colName + "\", \"runnerState\", \""
						+ event.colVal + "\")'>" + isRunner + "</div>";
			} else {
				event.html = isRunner;
			}
		} else if (event.colName == 'noticeType') {
			var noticeType = event.colVal;
			var noticeTypeState = this.comp("noticeTypeState");
			noticeTypeState.each(function(p) {
				var row = p.row;
				if (event.colVal && (row.val("code") == event.colVal)) {
					noticeType = row.val("name");
					if(event.colVal == "3") {
						noticeType = "    ";
					}
					p.cancel = true;
				}
			});
			noticeType = noticeType || "    ";
			state = this.comp("workTicket").getValue("state");
			if(event.colVal == "3") {
				noticeType = "          ";
			}
			if (!(this.readonlyData.get()) && state == "1") {
				event.html = "<div class='btn-link grid-link' onclick='justep.Bind.contextFor(this).$model.updateSafty(event,\"" + event.rowID + "\", \"" + event.colName
						+ "\", \"noticeTypeState\", \"" + event.colVal + "\")'>" + noticeType + "</div>";
			} else {
				event.html = noticeType;
			}
		}// else if(event.colName == "securityMeasuresContent" ||
			// event.colName == "remark") {
		// state = this.comp("workTicket").getValue("state");
		// if(!(this.readonlyData.get()) && state == "1") {
		// if(event.colVal && event.colVal !== "") {
		// event.html = "<div class='inputCss'>"+event.colVal+"</div>";
		// } else {
		// event.html = "<div class='inputCss'>&nbsp;</div>";
		// }
		// }
		// }
		else if(event.colName == 'securityMeasuresContent') {
			var locationName = this.comp("workTicket").getValue("locationName") || "";
			var val = event.colVal || "";
			val = val.replace(new RegExp(/( )/g), locationName) || "";
			event.html = val;
		}*/
	};

	// 数据建模
	Model.prototype.modelModelConstruct = function(event) {
//		var code = this.comp("code");
//		code.filters.clear();
//		code.setFilter("filter1", "SA_Code.sType='zh_ticketState' or SA_Code.sType='zh_perform' or " + "SA_Code.sType='zh_person' or SA_Code.sType='zh_listing'");
//		code.setOrderBy("sCode", 1);
//		code.refreshData();
//
//		var ticketState = this.comp("ticketState");
//		var executeState = this.comp("executeState");
//		var runnerState = this.comp("runnerState");
//		var noticeTypeState = this.comp("noticeTypeState");
//
//		code.each(function(p) {
//			var row = p.row;
//			if (row.val("sType") == "zh_ticketState") {
//				ticketState.add({
//					name : row.val("sName"),
//					code : row.val("sCode")
//				});
//			} else if (row.val("sType") == "zh_perform") {
//				executeState.add({
//					name : row.val("sName"),
//					code : row.val("sCode")
//				});
//			} else if (row.val("sType") == "zh_person") {
//				runnerState.add({
//					name : row.val("sName"),
//					code : row.val("sCode")
//				});
//			} else if (row.val("sType") == "zh_listing") {
//				noticeTypeState.add({
//					name : row.val("sName"),
//					code : row.val("sCode")
//				});
//			}
//		});
	};

	
	Model.prototype.checkeDangerPoint = function() {
//		var dangerPoint = this.comp("dangerPoint");
//		var preventionMeasures = this.comp("queryPreventionMeasures");
//		var currentWindow = $(this.getElementByXid("window"));
////		var index = $(".mytab", currentWindow).filter(".active").index();
//		
//		if(dangerPoint.getCount() === 0) {
//			justep.Util.hint("危险点必须填");
////			if(index != 3) {
////				$(".mytab", $(this.getElementByXid("window")))[3].click();
////			}
//			event.cancel = true;
//			return false;
//		} else {
//			var isOK = true;
//			dangerPoint.each(function(p) {
//				var row = p.row;
//				
//				preventionMeasures.filters.clear();
//				preventionMeasures.setFilter("filter1", "ZH_PreventionMeasures.dangerPintID = '" + row.getID() + "'");
//				preventionMeasures.refreshData();
//				
//				if(preventionMeasures.getCount() === 0) {
//					justep.Util.hint(row.val("hazardCode") + ":危险点安措必须填");
////					if(index != 3) {
////						$(".mytab", currentWindow)[3].click();
////					}
//					p.cancel = true;
//					isOK = false;
//				}
//			});
//			return isOK;
//		}
	};
	
	Model.prototype.button19Click = function(event){//选择危险点
//		var dangerPoint = this.comp("dangerPoint");
//		dangerPoint.newData();
		this.comp("standardHazardDialog").open();
	};
	
	Model.prototype.button21Click = function(event){//删除数据
		var safetyMeasures = this.comp("safetyMeasures");
		safetyMeasures.deleteData();
	};

	
	Model.prototype.button35Click = function(event){//删除危险点控制因素
		var dangerPoint = this.comp("dangerPoint");
		dangerPoint.deleteData();
	};

	
	Model.prototype.row10Click = function(event){ 
		var dangerPointData = this.comp("dangerPoint");
		var mainData = this.comp("mainData");
		var state = mainData.val("state");
		var rowID = dangerPointData.getCurrentRowID();
		var standardHazardID = dangerPointData.val("standardHazardID");
		this.comp("pointDialog").open({data : {id : standardHazardID, fID : rowID,state : state}});
	};

	
	Model.prototype.processBeforeAdvanceQuery = function(event){
		var dangerPoint = this.comp("dangerPoint");
		var preventionMeasures = this.comp("queryPreventionMeasures");
		var self = this;
		var flag = true;
		if(dangerPoint.getCount() === 0) {
			justep.Util.hint("危险点必须填");
			this.comp("contents").to("pointView");//跳转到危险点页面
			this.getElementByXid("button19").style.display = "block";
			event.cancel = true;
		} else {
			var isOK = true;
			dangerPoint.each(function(p) {
				var row = p.row;
				
				preventionMeasures.filters.clear();
				preventionMeasures.setFilter("filter1", "ZH_PreventionMeasures.dangerPintID = '" + row.getID() + "'");
				preventionMeasures.refreshData();
				
				if(preventionMeasures.getCount() === 0) {
					flag = false;
					justep.Util.hint(row.val("hazardCode") + ":危险点安措必须填");
					p.cancel = true;
					dangerPoint.to(row);
					self.row10Click(event);
//					var rowID = row.getID();
//					var standardHazardID = row.val("standardHazardID");
//					this.comp("pointDialog").open({data : {id : standardHazardID, fID : rowID}});
					
				}
			});
			if(!flag){
				event.cancel = true;
			}
		}
	};
	
	Model.prototype.modelLoad = function(event){
		this.getElementByXid("button4").style.display = "none";  //none--隐藏    block--显示
		this.getElementByXid("button19").style.display = "none";
		var mainData = this.comp("mainData");
		var state = mainData.val("state");
		if("2" == state){
		var approvalStartTime = mainData.getValue("approvalStartTime");
			var approvalEndTime = mainData.getValue("approvalEndTime");
			if(!approvalStartTime || approvalStartTime === "") {
				var planStartTime = mainData.getValue("planStartTime");
				mainData.setValue("approvalStartTime", planStartTime);
			}
			if(!approvalEndTime || approvalEndTime === "") {
				var planEndTime = mainData.getValue("planEndTime");
				mainData.setValue("approvalEndTime", planEndTime);
			}
			mainData.saveData();
		}
	};
	
	
	
	Model.prototype.processBeforeStart = function(event){
		var data = this.comp("mainData");
		var state = data.getValue("state");
		if(state == '4') {// 执行安措
			this.checkeSafetyMeasures();
		}

	};
	
	Model.prototype.checkeSafetyMeasures = function() {
		var safetyMeasures = this.comp("safetyMeasures");
		var flag = true;
		safetyMeasures.each(function(p){
			var row = p.row;
			var isExecute = row.val("isExecute");
			if(!isExecute) {
				justep.Util.hint("安全措施<span class='alert-danger'>是否执行必填</span>（" + row.val("securityMeasuresContent") + "）");
				flag = false;
				p.cancel = true;
			}
		});
		return flag;
	};
	
	Model.prototype.processBeforeOpenDialog = function(event){
		var data = this.comp("mainData");
		var state = data.getValue("state");
		if(state == '8') {// 终结前
			this.comp("popMenu1").show();
		}
	};
	
	Model.prototype.button16Click = function(event){
		this.comp("mainData").setValue("autoStartOrder", "0");
		this.comp("popMenu1").hide();
	};
	
	Model.prototype.button18Click = function(event){
		this.comp("mainData").setValue("autoStartOrder", "1");
		this.comp("popMenu1").hide();
	};
	
	Model.prototype.standardHazardDialogClose = function(event){
		var mainData = this.comp("mainData");
		var dangerPoint = this.comp("dangerPoint");
//		mainData.saveData();
		dangerPoint.saveData();
	};
	
	Model.prototype.processAdvanceCommit = function(event){
		justep.Util.hint("流转成功");
	};
	
	Model.prototype.saveButtonClick = function(event){//保存后刷新数据
		var mainData = this.comp("mainData");debugger;
		mainData.saveData();
		this.comp('mainData').saveData(
				{
					"onSuccess" : function(event) {debugger;
						var workTicketCode = mainData.val("ZH_WorkTicket");
						// 不设置会将当前数据刷新
						mainData.setFilter("filter23", "ZH_WorkTicket='"
								+ workTicketCode + "'");
						mainData.refreshData();
						justep.Util.hint("保存成功");
					},
					"onError" : function(event){debugger;
						justep.Util.hint("保存失败");
					}
				});
				mainData.refreshData();
	};
	

	Model.prototype.mainViewInactive = function(event){debugger;
		var mainData = this.comp("mainData");
		var state = mainData.val("state");
		if('0' == state || '1' ==state){
			//如果有主表数据没有保存，提示先保存数据
			var isValid = mainData.isValid();
			if(isValid){
//			mainData.isValid(true);
				var detailBtn = this.comp("button42");
				this.saveButtonClick(event);
				detailBtn.set({target:"detailView"});
			}else{
				var detailBtn = this.comp("button42");
//				detailBtn.target("mainView");
//				this.comp("button42").
				detailBtn.set({target:"mainView"});
				justep.Util.hint("有数据没有通过，请填写数据");
//				detailBtn.s
			}
		}
	};

	Model.prototype.mainViewActive = function(event){//进入页面
		this.getElementByXid("button4").style.display = "none";  //none--隐藏    block--显示
		this.getElementByXid("button19").style.display = "none";
	};

	Model.prototype.detailViewActive = function(event){	
		this.getElementByXid("button4").style.display = "block";  //none--隐藏    block--显示
		this.getElementByXid("button19").style.display = "none";
		var mainData = this.comp("mainData");
		var state = mainData.val("state");
		if('0' == state || '1' ==state){
		}else{
			this.getElementByXid("button4").style.display = "none";  //none--隐藏    block--显示
			this.getElementByXid("button19").style.display = "none";
		}
		if (!(this.readonlyData.get()) && state == '1') {
			safetyMeasuresIsReadonly = false;
		}else{
			safetyMeasuresIsReadonly = true;
		}
	};

	Model.prototype.detailViewInactive = function(event){//离开页面
		this.getElementByXid("button4").style.display = "none";  //none--隐藏    block--显示
	};

	Model.prototype.pointViewActive = function(event){
		this.getElementByXid("button4").style.display = "none";  //none--隐藏    block--显示
		this.getElementByXid("button19").style.display = "block";	
		var mainData = this.comp("mainData");
		var state = mainData.val("state");
		if('0' == state || '1' ==state){
		}else{
			this.getElementByXid("button4").style.display = "none";  //none--隐藏    block--显示
			this.getElementByXid("button19").style.display = "none";
		}		
	};

	Model.prototype.pointViewInactive = function(event){
		this.getElementByXid("button19").style.display = "none";
	};

	Model.prototype.button22Click = function(event){

	};

	Model.prototype.mainDataIndexChanged = function(event){

		// 设置数据权限
		if (!event.row) {
			this.readonlyData.set(true);
			return;
		}
//		var id = event.row.getID();
//		var taskData = this.getTaskBysData1(id);
//		if (taskData && taskData.getCount() > 0) {
//			var sStatusID = taskData.getValue("sStatusID");
//			if (sStatusID == "tesAborted" || sStatusID == "tesFinished") {
//				this.readonlyData.set(true);
//				return;
//			}
//			if (this.getContext().getCurrentPersonID() !== taskData.getValue("sExecutorPersonID")) {
//				this.readonlyData.set(true);
//				return;
//			}
//			this.readonlyData.set(false);
//		} else {
//			this.readonlyData.set(false);
//		}
	};
	
	// 根据缺陷id获取流程当前环节task
	Model.prototype.getTaskBysData1 = function(rowID) {
		var name = this.getContext().getCurrentPersonID() + rowID;
		var value = this.tasks[name];
		if(value) {
			return value;
		}
		
		var taskData = this.comp("taskData");
		taskData.clear();
		taskData.filters.clear();
		taskData.filters.setStringVar("sData1", rowID);
		taskData.setFilter("filter1", "SA_Task.sData1=:sData1");
		// 去掉条件流转
		taskData.setFilter("filter4", "SA_Task.sEURL is not null and SA_Task.sCURL is not null");
		taskData.setFilter("filter3", "SA_Task.sKindID='tkTask' or SA_Task.sKindID='tkExecutor' or SA_Task.sKindID IS NULL");
		taskData.setFilter("filter2", "SA_Task.sProcess='/IOMM/fieldManagement/process/windWorkTicket/windWorkTicketProcess'");
		taskData.setOrderBy("sData1", 1);
		taskData.setOrderBy("sCreateTime", 0);
		taskData.setOrderBy("sKindID", 0);
		taskData.setOrderBy("sAIStatusID", 0);
		taskData.refreshData();
		
		var task = {};
		task.getCount = function() {
			return task.count;
		};
		task.getRowID = function() {
			return task.rowID;
		};
		task.getValue = function(name) {
			return task[name];
		};
		
		task.count = taskData.getCount();
		if(task.count > 0) {
			task.rowID = taskData.getRowID();
			task.sStatusID = taskData.getValue("sStatusID");
			task.sActivity = taskData.getValue("sActivity");
			task.sExecutorPersonID = taskData.getValue("sExecutorPersonID");
		}
		this.tasks[name] = task;
		
		return task;
	};

	Model.prototype.button42Click = function(event){
		var contents = this.comp("contents");
		var mainData = this.comp("mainData");
		var state = mainData.val("state");
		if('0' == state || '1' ==state){
			//如果有主表数据没有保存，提示先保存数据
			var isValid = mainData.isValid();
			if(isValid){
				var detailBtn = this.comp("button42");
				this.saveButtonClick(event);
				detailBtn.set({target:"detailView"});
				contents.to("detailView");
			}else{
				justep.Util.hint("有数据没有通过，请填写数据");
			}
		}
	};
	return Model;
});
